#! /usr/bin/env python

# import standard modules

# import custom modules
from utils.error import MyError

# CONSTANTS

class TokenizerCls: #{
  def __init__(self, input_string, delimiter="\t", log_info=dict()): #{
    self.log_info = log_info
    self.delimiter = delimiter
    self.fields = input_string.split(delimiter)
    self.index = 0
  #} end def

  def __iter__(self): #{
    return self
  #} end def

  def next(self): #{
    if (len(self.fields) <= self.index): #{
      raise StopIteration
    #} end if
    self.index += 1
    return self.fields[self.index-1]
  #} end def

  def Reset(self): #{
    self.index = 0
  #} end def
#} end class

class ParseWarningCls: #{
  def __init__(self, warning, data, rule=""): #{
    self.warning = warning
    self.data    = data
    self.rule    = rule
  #} end def
#} end class

def GetFieldAndValue(field_str): #{
  return field_str.split(":", 1)
#} end def

def GetFieldValue(field_str): #{
  try:
    return GetFieldAndValue(field_str)[1]
  except IndexError, e:
    raise TokenizerError \
      ("Error getting field value from \"%s\": %s" % (field_str, e))
  # end try
#} end def

#### EXCEPTION CLASSES ####
class TokenizerError(MyError): #{
  pass
#} end class
